------------------------------------------------------------------------------
------------------------------------------------------------------------------
-- Cheddar is a free real time scheduling tool.
-- This program provides services to automatically check temporal constraints
-- of real time tasks.
--
-- Copyright (C) 2002-2009   Frank Singhoff
-- Cheddar is developped by the LISYC Team, University of Brest
--
-- This program is free software; you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation; either version 2 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program; if not, write to the Free Software
-- Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
--
--
-- Contact : F. Singhoff (singhoff@univ-brest.fr)
--
------------------------------------------------------------------------------
------------------------------------------------------------------------------

with Text_IO; use Text_IO;

package body Version is

   procedure Copyright (Program_Name : in String) is
   begin
      Put_Line
        (Program_Name &
         " version " &
         Cheddar_Version &
         ", Copyright (C) 2002-2009, F. Singhoff");
      Put_Line (Cheddar_Compile_Date);
      Put_Line
        (Program_Name &
         " is developed by the LISYC Team, University of Brest");
      Put_Line (Program_Name & " comes with ABSOLUTELY NO WARRANTY; ");
      Put_Line
        ("This is free software, and you are welcome to redistribute it");
      Put_Line(
"under certain conditions; See the GNU General Public License for details.");
   end Copyright;

end Version;
