with Text_IO;          use Text_IO;
with Ada.Numerics.Aux; use Ada.Numerics.Aux;

package Standards_Io is

   package Natural_Io is new Text_IO.Integer_IO (Natural);
   use Natural_Io;
   package Integer_Io is new Text_IO.Integer_IO (Integer);
   use Integer_Io;
   package Boolean_Io is new Text_IO.Enumeration_IO (Boolean);
   use Boolean_Io;
   package Double_Io is new Text_IO.Float_IO (Double);
   use Double_Io;

end Standards_Io;
