with Statements;  use Statements;
use Statements.Sets_Type_Package;
with Expressions; use Expressions;
use Expressions.Variables_Type_Package;

package Parser is

   -- Function to parse a scheduler behavior
   --
   procedure Yyparse;

   -- Initiliaze parser Data
   -- Do initialize Simulation Data all together
   --
   procedure Init_Parser;

   -- Stores the first statement
   --
   Root_Statement_Pointer : Section_Pointers;

   -- Table to store the list of Variables of
   -- a parametric scheduler
   --
   Variables_Table : Variables_Table_Type;

   -- Table to store the list of "set" statements
   -- in a parametric scheduler
   --
   Sets_Table : Sets_Table_Type;

   -- Display list of Statements contained
   -- in a section
   --
   procedure Put (S : in Section_Pointers);

end Parser;
